//+------------------------------------------------------------------+
//|                                                Retracement.mq4   |
//|                                      Copyright  2006, D Clarke  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, D Clarke"
#property link      ""

extern int    _MagicNumber = 1123;
extern int    StopLoss1     = 65;////75//64017 distance to StopLoss in points (0 - disable)
extern int    TakeProfit1   = 280;//// distance to TakeProfit in points (0 - disable)
extern int    TrailingStop1 = 80;// Trailing Stop in points (0 - disable)
extern int takeprofitpercent = 100;
extern int risk1 = 10; 
extern int optimize = 300; 
int start()
{
//---------------------------------------------------------------------------//
//Limit usage for the stipulated account code
/*
int hard_accnt = 77884; //<-- type the user account here before compiling
  int accnt = AccountNumber();
  
   if (accnt != hard_accnt)
   {
      Alert ("You can not use this account (" + DoubleToStr(accnt,0) + ") with this program!"); 
      return(0);
   }
*/  
   //make sure all period graphs are Open
//+------------------------------------------------------------------+
//|    SETTING INTERNAL VARIABLES                                    |
//+------------------------------------------------------------------+ 
double  StopLoss, TakeProfit, TrailingStop, pointfactor, point1;

//we need to find the number of digits in the currency so if they increase by 1 trading values will adapt
point1 = Point;
//Print("point1: ",point1);
if(point1 == 0.01) pointfactor=1;  //if digits = 0.0001 x by 1 if 0.00001 then x by 10
if(point1 == 0.001) pointfactor=10; 
//Print("pointfactor: ",pointfactor);
StopLoss     = StopLoss1*pointfactor ;
TakeProfit   = TakeProfit1*pointfactor;
TrailingStop = TrailingStop1*pointfactor;

double mintradetime,orderexpire,CCI_Period,T3_Period,madailyPERIOD,mamin15PERIOD,ROChma,roclonglevel,rocshortlevel,ROCdma,breaklookback,break1,longmove,longmove1,lmlookback,bigmove,bigmove1,bmlookback,tail,tail1,Afternoonst,Afternoonend,Morningst,Morningend,Weeklylookback,weeklyPeriod,afterweeklylevel,beforeweeklylevel;   

//---------------------------------------------------------------------------//
/*NOTES
seem to be hitting SL too aften 
try increasing SL and increasing break
*/
//---------------------------------------------------------------------------//
//Version 4 settings

//Required move above high and low level
break1=35;//40;//
breaklookback=16;
//Required move to be considered retracement candidate
bigmove=310 ;//
//short move lookback
bmlookback=16;//
//15 min CCI settings
CCI_Period=36;//44;//36;//30;
T3_Period=10;
//Time the stop order must be active
orderexpire=120;
//Time the trade must be open
mintradetime=60;//60;//


//---------------------------------------------------------------------------//
//Money managrement
//Calculate the number of contracts for optimum risk
double Lots,spread ;
spread = Ask-Bid;//spread of the currency
//Print("Spread: ",spread);
double risk = risk1*0.01;
double valueperpip = 1;
double riskvalue = (risk*(AccountBalance( )/3));
double lossvalue = (StopLoss+(spread/Point))*valueperpip;
double contracts = 1;//NormalizeDouble(((riskvalue/lossvalue)/(10/pointfactor)),2);//the contract value will be limited to the potential maximum loss(stoploss) that equates to the risk% of total capital 
if(contracts<0.01) Lots=0.01; else Lots=contracts;                                //you shouldn't lose more than the set risk x capital balance    
if(contracts>15) Lots=15; else Lots=contracts;

//Print("riskvalue: ",riskvalue);
//Print("lossvalue: ",lossvalue);
//Print("contracts: ",contracts);


//---------------------------------------------------------------------------//
//Conversion values for decimals

double pointfactor2,point2,digits2;
point2 = Point;
//Print("point1: ",point1);
if((point2 == 0.01) || (point2 == 0.001)) pointfactor2=100;  //if digits = 0.0001 x by 1 if 0.00001 then x by 10
if((point2 == 0.0001) || (point2 == 0.00001)) pointfactor2=10000;   
if((point2 == 0.01) || (point2 == 0.001)) digits2=0.01;  //if digits = 0.0001 x by 1 if 0.00001 then x by 10
if((point2 == 0.0001) || (point2 == 0.00001)) digits2=0.0001; 

//---------------------------------------------------------------------------//
//Calculate pending entry prices "break"
double hhv,hhv1,longprice,longprice1,llv,llv1,shortprice,shortprice1,expiration;

hhv=iCustom(NULL,PERIOD_M1,"Retracement break",0,breaklookback,0,0);//used the indicator values from the Break level file
longprice=NormalizeDouble(hhv + (break1*digits2),Digits);

llv=iCustom(NULL,PERIOD_M1,"Retracement break",0,breaklookback,1,0);//used the indicator values from the Break level file
shortprice=NormalizeDouble(llv - (break1*digits2),Digits);

//Print("shortprice =" + shortprice + " : longprice = " + longprice);
//Print("shortstop =" + (shortprice+spread+(StopLoss*Point)) + " : longstop = " + (longprice-(StopLoss*Point)));
//Print("shortprofit =" + (shortprice+spread-(TakeProfit*Point)) + " : longprofit = " + (longprice+(TakeProfit*Point)));

//Print("shortprice =" + shortprice + " : longprice = " + longprice);
//Print("shortstop =" + (shortprice+spread+(StopLoss*Point)) + " : longstop = " + (longprice-(StopLoss*Point)));
//Print("shortprofit =" + (shortprice+spread-(TakeProfit*Point)) + " : longprofit = " + (longprice+(TakeProfit*Point)));

//confirmed values in expert = the indicator

//---------------------------------------------------------------------------//

//Calculate the price move over the period before entry
double moveup,movedown,downmove,upmove,upmove1,upmove2,upmove3,downmove1,downmove2,downmove3 ;

upmove=iCustom(NULL,PERIOD_M15,"Retracement3",(bigmove),bmlookback,2,0)*pointfactor2;//used the indicator values from the Short move file
downmove=iCustom(NULL,PERIOD_M15,"Retracement3",(bigmove),bmlookback,5,0)*pointfactor2;//used the indicator values from the Short move file

if(upmove >=bigmove ) moveup = true;// has moved enough to be considered a candidate for short retracement
if(downmove >=bigmove) movedown = true;// has moved enough to be considered a candidate for long retracement

//if(upmove >=bigmove || upmove1 >=bigmove || upmove2 >=bigmove) moveup = true;// has moved enough to be considered a candidate for short retracement
//if(downmove >=bigmove || downmove1 >=bigmove || downmove2 >=bigmove) movedown = true;// has moved enough to be considered a candidate for long retracement

//if(upmove>bigmove) moveup = true;// has moved enough to be considered a candidate for short retracement
//if(downmove>bigmove) movedown = true;// has moved enough to be considered a candidate for long retracement
//Print("bigmove", bigmove);

//Print("upmove =" + upmove + " : upmove1 = " + upmove1);
//Print("down move =" + downmove + " : up move = " + upmove);
//if(moveup==true) Print("upmove =" + upmove + " : upmove1 = " + upmove1);
//if(movedown==true) Print("down move =" + downmove);   

//---------------------------------------------------------------------------//
//Calculate take profit based on fib % level

double Llv,Hhv,Takelongprofit, Takeshortprofit,Takeshortprofitpercent,Takelongprofitpercent,maxupmove,maxupmove1,maxdownmove,maxdownmove1;
Hhv=iCustom(NULL,PERIOD_M15,"Retracement3",(bigmove),bmlookback,0,0);//current high for the upmove
Llv=iCustom(NULL,PERIOD_M15,"Retracement3",(bigmove),bmlookback,3,0);//current low for the down move

Takelongprofitpercent   = NormalizeDouble(downmove*(takeprofitpercent*0.01),0);//total downmove x percent
Takeshortprofitpercent   = NormalizeDouble(upmove*(takeprofitpercent*0.01),0);//total upmove x percent
Takelongprofit = NormalizeDouble((Llv + (Takelongprofitpercent*digits2)),Digits);//Take profit value
Takeshortprofit = NormalizeDouble((Hhv - (Takeshortprofitpercent*digits2)),Digits);//Take profit value
//Print("Takeshortprofit =" + Takeshortprofit + " : Takelongprofit = " + Takelongprofit);
//Print(llv,Digits);
//---------------------------------------------------------------------------//
//Calcualtion of the CCI values
double cci1,cci2,cciup,ccidown,ccioverbought,ccioversold;
cci1=iCustom(NULL,PERIOD_M15,"CCI ind",false,CCI_Period,T3_Period,0,0);
cci2=iCustom(NULL,PERIOD_M15,"CCI ind",false,CCI_Period,T3_Period,0,1);

if(cci1>cci2) cciup = true;
if(cci1<cci2) ccidown = true;
if(cci1>150) ccioverbought = true;
if(cci1<(-150)) ccioversold = true;
//Print("cci1 =" + cci1 + " : cci2 = " + cci2);

//---------------------------------------------------------------------------//
//expiration=pending order will expire after x hours or at end of trading session incase no connection with server
double CurrentHour,CurrentDay;
CurrentHour=iCustom(NULL,PERIOD_H1,"Time hourly",40,0,0);//used the Hour indicator values from the Time hourly.mq4
CurrentDay=iCustom(NULL,PERIOD_D1,"Time Dayofweek",40,0,0);//used the Dayofweek indicator values from the Time dayofweek.mq4
//Print ("Hour : " , CurrentHour);
//Print ("Day : " , CurrentDay);
/*
if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==17  )  ) expiration=CurTime()+(1*3600);
if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==16  )  ) expiration=CurTime()+(2*3600);
if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==15  )  ) expiration=CurTime()+(3*3600);
if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==14  )  ) expiration=CurTime()+(4*3600);
if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==13  )  ) expiration=CurTime()+(5*3600);
if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==12  )  ) expiration=CurTime()+(5*3600);
if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==11  )  ) expiration=CurTime()+(5*3600);
if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==10  )  ) expiration=CurTime()+(5*3600);


if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==4  )  ) expiration=CurTime()+(1*3600);
if( CurrentDay==1 || CurrentDay==2  || CurrentDay==3 || CurrentDay==4  || CurrentDay==5 && ( CurrentHour==3  )  ) expiration=CurTime()+(2*3600);

*/ 
expiration=CurTime()+(6*1800);
//---------------------------------------------------------------------------//
//Session timing
double day1,day2,day3,day4,day5,sessionisopen,time1,time2,time3,day1to3,day4to5,weekend;
/*


//Session times Monday to Wednesday
if( ( (CurrentHour>=Morningst && CurrentHour<=Morningend)  ||  (CurrentHour>=Afternoonst && CurrentHour<=Afternoonend) )  ) time1=true;
if( CurrentDay>=0 && CurrentDay<=3 ) day1to3=true;//Monday to Wednesday

//Session times Thurday to Friday
if( ( (CurrentHour>=Morningst && CurrentHour<=Morningend)  ||  (CurrentHour>=Afternoonst && CurrentHour<=Afternoonend) )  ) time2=true;//Session times Thurday to Friday
if( CurrentDay>=4 && CurrentDay<=5 ) day4to5=true;//Thurday to Friday              
/*===NOTE===you can't combine days with time like this if(days && time) something=true; for use in opening an Order
 but if they are spesified separately in the order function it works*/

//if( ( (day1to3==true && time1==true)  ||  (day4to5==true && time2==true) )  ) sessionisopen=true; 
//---------------------------------------------------------------------------//
//Print status report
//Alert only once the condition met
/*
some condition
*/
       
//==================================================================================//

double shortconditions,longconditions,sellconditions,coverconditions;
//+------------------------------------------------------------------+
//|    BUY CONDITIONS                                                |
//+------------------------------------------------------------------+
if(movedown == true && ccioversold == true) longconditions=true;


//+------------------------------------------------------------------+
//|    SELL CONDITIONS                                               |
//+------------------------------------------------------------------+
// 

//+------------------------------------------------------------------+
//|    SHORT CONDITIONS                                              |
//+------------------------------------------------------------------+
if( moveup == true && ccioverbought == true) shortconditions=true;//profit factor is higher as less trades are taken


//+------------------------------------------------------------------+
//|    COVER CONDITIONS                                              |
//+------------------------------------------------------------------+
// 


//========================================================================================================================//

//+------------------------------------------------------------------+
//|    CHECK STATUS OF THE TRADING TERMINAL                          |
//+------------------------------------------------------------------+
// Variables, in which tickets of orders of each type will be 
// memorized
    int BuyStopOrder = 0, SellStopOrder = 0, BuyOrder = 0, 
    SellOrder = 0;
    int _GetLastError = 0, _OrdersTotal = OrdersTotal();
// search in all open positions and memorize, positions of which 
// type have already been opened:
    for ( int z = _OrdersTotal - 1; z >= 0; z -- )
    {
        // if an error occurs at searching for a position, go 
        // to the next one
        if ( !OrderSelect( z, SELECT_BY_POS ) )
        {
          _GetLastError = GetLastError();
          Print("OrderSelect(", z, ", SELECT_BY_POS) - Error #",
               _GetLastError );
          continue;
        }
 
// if the position was opened not for the current symbol, skip it
        if ( OrderSymbol() != Symbol() ) continue;
 
// if the MagicNumber is not equal to _MagicNumber, skip this 
// position
        if ( OrderMagicNumber() != _MagicNumber ) continue;
 
        // depending on the position type, change value of the 
        // variable:
        switch ( OrderType() )
        {
          case OP_BUY:      BuyOrder      = OrderTicket(); break;
          case OP_SELL:     SellOrder     = OrderTicket(); break;
          case OP_BUYSTOP:  BuyStopOrder  = OrderTicket(); break;
          case OP_SELLSTOP: SellStopOrder = OrderTicket(); break;
        }
    }
//====================================================================================================//     
//+------------------------------------------------------------------+
//|    CHECK IF IT'S TIME TO CANCEL OR AMEND PENDING ORDERS          |
//+------------------------------------------------------------------+    
 int cnt, cmd, total;   
 total=OrdersTotal();
    
   for(int i=0; i<total; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
       {
       if ( OrderMagicNumber() == _MagicNumber )
       {
         cmd=OrderType();
         //---- pending orders only are considered
         if(cmd!=OP_BUY && cmd!=OP_SELL)
        {
 //+------------------------------------------------------------------+
///|    CHECK THE BUY ORDERS                                          |
///+------------------------------------------------------------------+ 
          if(OrderType()==OP_BUYSTOP)         // pending orders are opened
           {                                  // should it be closed?
               //Print("BUYSTOPPRICE: ",OrderOpenPrice( ) );
               //Print("LONGPRICE: ",(longprice+spread));
                if(((CurTime()-OrderOpenTime())>60*orderexpire))  //close pending order at end of trading session or if conditions no longer true
                 {
                  if(!OrderDelete(OrderTicket()))  // close pending order
                  {
                              Alert("buystop delete Error GBPJPY#",GetLastError());
                              return(-1);
                  }else Alert("buystop delete GBPJPY",OrderPrint());
                  return(0); // exit
                 }
                // check if pending buy price must be changed
                if(((OrderOpenPrice( )/Point)- (NormalizeDouble((longprice+spread), Digits )/Point))>=1 || ((OrderOpenPrice( )/Point)- (NormalizeDouble((longprice+spread), Digits )/Point))<=-1)//entry price only to be changed if diff to price in the order  
                 {
                  //Print("BUYorderprice:", ((OrderOpenPrice( )/Point)- (NormalizeDouble((longprice+spread), Digits )/Point)));
                  //---- modify the order
                  if(!OrderModify(OrderTicket(),longprice+spread,longprice-(StopLoss*Point),Takelongprofit,expiration,Green))
                  {
                              Alert("buystopOrderModify Error GBPJPY#",GetLastError());
                              return(-1);
                  }else Alert("buystop Modify GBPJPY",OrderPrint());
                  Sleep(10000);
                  return(0);
                 }
           }
//+------------------------------------------------------------------+
//|    CHECK THE SELL ORDERS                                         |
//+------------------------------------------------------------------+             
          if(OrderType()==OP_SELLSTOP)      // pending orders are opened
           {                                   // should it be closed?
                
                if(((CurTime()-OrderOpenTime())>60*orderexpire) )    //close pending order at end of trading session or if conditions no longer true
                 {
                  if(!OrderDelete(OrderTicket()))   // close pending order
                  {
                              Alert("Sellstop delete Error GBPJPY#",GetLastError());
                              return(-1);
                  }else Alert("sellstop delete GBPJPY",OrderPrint());
                  return(0); // exit
                 }
                // check if pending sell price must be changed
                if(((OrderOpenPrice( )/Point)- (NormalizeDouble((shortprice), Digits )/Point))>=1 || ((OrderOpenPrice( )/Point)- (NormalizeDouble((shortprice), Digits )/Point))<=-1)//entry price only to be changed if diff to price in the order  
                 {
                  //---- modify the order
                  if(!OrderModify(OrderTicket(),shortprice,shortprice+spread+(StopLoss*Point),spread+Takeshortprofit,expiration,Green))//sellprice will be the ask price so it's graph price + spread
                  {
                              Alert("sellstopOrderModify Error GBPJPY#",GetLastError());
                              return(-1);
                  }else Alert("sellstop Modify GBPJPY",OrderPrint());
                  Sleep(45000);
                  return(0);
                 }
           } 
        }
       }
       }
        else { Print( "Error when order select GBPJPY", GetLastError()); break; }
     }
 //====================================================================================================//     
  
    //---- If we have both pending orders, quit, 
    //---- we have to wait until one of them triggers
    if ( BuyStopOrder > 0 && SellStopOrder > 0 ) return(0);
 
    // search in all open positions for the second time - now 
    // we will work with them:
    _OrdersTotal = OrdersTotal();
    for ( z = _OrdersTotal - 1; z >= 0; z -- )
    {
        // if an error occurs in searching a position, go to 
        // the next one
        if ( !OrderSelect( z, SELECT_BY_POS ) )
        {
            _GetLastError = GetLastError();
            Print("OrderSelect(", z, ", SELECT_BY_POS) - Error #", 
                  _GetLastError );
            continue;
        }
 
        // is the position was opened not for the current symbol,
        // skip it
        if ( OrderSymbol() != Symbol() ) continue;
 
        // if the MagicNumber does not equal to _MagicNumber, 
        // skip this position
        if ( OrderMagicNumber() != _MagicNumber ) continue;
 
        // depending on the position type, change the variable 
        // value:
        switch ( OrderType() )
        {
            //---- if there is an open BUY position,
//+------------------------------------------------------------------+
//|    CHECK FOR SELL CONDITIONS                                     |
//+------------------------------------------------------------------+  
            case OP_BUY:
            {
                // if the SellStop order has not been deleted 
                // yet, delete it:
                if ( SellStopOrder > 0 )
                {
                  if ( !OrderDelete( SellStopOrder ) )
                  {
                    Alert("OrderDelete Error GBPJPY#", GetLastError());
                    return(-1);
                  }
                }
                if(((ccidown==true) && ((CurTime()-OrderOpenTime())>60*mintradetime)) )//order must be open for 1 hour before closed
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
                // check whether the StopLoss should be moved:
                // if the size of Trailing Stop is not very small,
                if(TrailingStop > MarketInfo( Symbol(), 
                   MODE_STOPLEVEL ) )
                {
                 if(TrailingStop>0)  
                  {                 
                   if(Bid>OrderOpenPrice())
                     {
                      if(OrderStopLoss()<NormalizeDouble(Bid - TrailingStop*Point, Digits ))//Stop will only be changed when the profit is 77 ( trail - stop)
                        {
                        //---- modify the order
                         if(!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid - TrailingStop*Point, Digits ),OrderTakeProfit(),OrderExpiration(),Green))
                            {
                              Alert("Modify trail Error GBPJPY#",GetLastError());
                              return(-1);
                            }else Alert("Buy trailing stop Modify GBPJPY",OrderPrint());
                        }
                     }
                  }
                }Sleep(10000);
                // if there is an open position, quit, there 
                // is nothing to do
                return(0);
            }
//+------------------------------------------------------------------+
//|    CHECK FOR COVER CONDITIONS                                    |
//+------------------------------------------------------------------+ 
            case OP_SELL:
            {
                if ( BuyStopOrder > 0 )//if buy stop still open then delete
                {
                    if ( !OrderDelete( BuyStopOrder ) )
                    {
                        Alert("OrderDelete Error GBPJPY#", GetLastError());
                       return(-1);
                    }
                }
                if(((cciup==true) && ((CurTime()-OrderOpenTime())>60*mintradetime)))//order must be open for 1 hour before closed
                 {
                  OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
                  return(0); // exit
                  }
                // check whether the StopLoss should be moved:
                // if the size of Trailing Stop is not very small,
                 if(TrailingStop > MarketInfo( Symbol(), 
                   MODE_STOPLEVEL ) )
                {
                  if(TrailingStop>0)  
                   {                 
                    if((OrderOpenPrice()>Ask))
                      {
                       if(OrderStopLoss()>NormalizeDouble(Ask + TrailingStop*Point,Digits ))
                         {
                         //---- modify the order
                          if(!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask + TrailingStop*Point,Digits),OrderTakeProfit(),OrderExpiration(),Red))
                            {
                              Alert("Modify trail Error GBPJPY#",GetLastError());
                              return(-1);
                            }else Alert("Sell trailing stop Modify GBPJPY",OrderPrint());
                         }
                      }
                   }
                }Sleep(10000);
                return(0);
            }
         }
    }
//+------------------------------------------------------------------+
//| If execution has reached this point, it means there are no       |
//| pending orders or open positions                                 |
//+------------------------------------------------------------------+
//---- Place BuyStop and SellStop:
 
//+------------------------------------------------------------------+
//|    CHECK FOR BUY CONDITIONS                                      |
//+------------------------------------------------------------------+
int ticket;
  if((longconditions == true || shortconditions == true))//check if session is open
     {
      //Print("SellStopOrder" + SellStopOrder + " : SellOrder= " + SellOrder + " : BuyOrder= " + BuyOrder);  
      // check for long position (BUY) possibility
           
      if(BuyStopOrder==0 && BuyOrder==0 && SellOrder==0 && longconditions == true && Ask<(longprice+spread))//check if long conditions are ok to place order and if order is above ask price
        {
         if ( BuyStopOrder > 0) return(0);
         ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,longprice+spread,3,longprice-(StopLoss*Point),Takelongprofit,"buy stop order",_MagicNumber,expiration,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY stop order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order GBPJPY: ",GetLastError()); 
         return(0); 
        }Sleep(60000);
//+------------------------------------------------------------------+
//|    CHECK FOR SHORT CONDITIONS                                    |
//+------------------------------------------------------------------+         
      // check for short position (SELL) possibility
     
      if(SellStopOrder==0 && SellOrder==0 && BuyOrder==0 && shortconditions == true && Bid>shortprice)//check if short conditions are ok to place order and if order is below bid price
     {
     if (SellStopOrder > 0 ) return(0); 
         ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,shortprice,3,shortprice+spread+(StopLoss*Point),spread+Takeshortprofit,"sell stop order",_MagicNumber,expiration,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL stop order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order GBPJPY: ",GetLastError()); 
         return(0); 
        }Sleep(60000);
      return(0);
     }
    return(0);
    
}
//FINISHED================================================================================================================//


//Tested




