//+------------------------------------------------------------------+
//|                                                   Break level.mq4|
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2006, D Clarke"
#property  link      ""
//---- indicator settings

#property  indicator_chart_window
#property  indicator_buffers 6
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_color3  Blue
#property  indicator_color4  LawnGreen
#property  indicator_width1  2
//----
#define arrowsDisplacement 0.0001
//---- indicator parameters
extern int break1 = 400;
extern int lookback=240; 
//---- indicator buffers
//declare arrays
double high[];
double low[];
double hhv[];
double llv[];
//the arrow direction needs their own buffers
double uptrend[];
double downtrend[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexStyle(5,DRAW_NONE);
   IndicatorDigits(Digits);
//---- indicator buffers mapping
    SetIndexBuffer(0, hhv); 
    SetIndexBuffer(1, llv);
    SetIndexBuffer(2, uptrend);
    SetIndexBuffer(3, downtrend);
    SetIndexBuffer(4, high);
    SetIndexBuffer(5, low);
  //----   
   SetIndexArrow(2, 233);//up arrow
   SetIndexArrow(3, 234);//down arrow
//----
//---- name for DataWindow and indicator subwindow label
IndicatorShortName("Break level(" + break1 + ")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Calculation                                                      |
//+------------------------------------------------------------------+
int start()
  {
  int limit,limit2,limit3;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

 
//Calculate the high for the period
for(int i=0; i<limit; i++)
     {
       high[i]=iHigh(NULL,0,i);
     } 
//Calculate the low price for the period
for(i=0; i<limit; i++)
     {
       low[i]=iLow(NULL,0,i);
     }     
    
//Calculate the HHV for the lookback period           
for(i=0; i<limit; i++)
     {
       hhv[i]=iLow(NULL,0,(Lowest(NULL,0,MODE_LOW,lookback,(i))))+break1*Point;//
       
       //Calculate the arrows
       if(hhv[i]<=high[i])//look for the condition of the arrow each bar is evaluated in the loop
       {uptrend[i]=high[i]+arrowsDisplacement;}// then return the value less the distance away from the value
     }
      
//Calculate the LLV of the ma for the lookback period      
for(i=0; i<limit; i++)
     {
       llv[i]=iHigh(NULL,0,(Highest(NULL,0,MODE_HIGH,lookback,(i))))-break1*Point;
       
       //Calculate the arrows
       if(llv[i]>=low[i])//look for the condition of the arrow each bar is evaluated in the loop
       {downtrend[i]=low[i]-arrowsDisplacement;} // then return the value less the distance away from the value      
     } 
 

//Print("HHV: ", DoubleToStr(hhv[0],5));     
//Print("LLV: ", DoubleToStr(llv[0],5));        
   return(0);
//NOTE   

   

//---- done

  }
//+------------------------------------------------------------------+