//+------------------------------------------------------------------+
//|                                                  Retracement3.mq4|
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2006, D Clarke"
#property  link      ""
//---- indicator settings

#property  indicator_chart_window
#property  indicator_buffers 8
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_color3  Blue
#property  indicator_color4  LawnGreen
#property  indicator_color6  Blue
#property  indicator_color7  LawnGreen
#property  indicator_width6  10
//----
#define arrowsDisplacement 0.0001
//---- indicator parameters
extern int shortmove = 1400;
extern int shortlookback=4;  
//---- indicator buffers
//declare arrays
double high[];
double shortlow[];
double upmove[];
double low[];
double shorthigh[];
double downmove[];
//the arrow direction needs their own buffers
double uptrend[];
double downtrend[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexStyle(7,DRAW_ARROW);
   IndicatorDigits(Digits);
//---- indicator buffers mapping
    SetIndexBuffer(0, high); 
    SetIndexBuffer(1, shortlow);
    SetIndexBuffer(2, upmove);
    SetIndexBuffer(3, low);
    SetIndexBuffer(4, shorthigh);
    SetIndexBuffer(5, downmove);
    SetIndexBuffer(6, uptrend);
    SetIndexBuffer(7, downtrend);
  //----   
   SetIndexArrow(6, 233);//up arrow
   SetIndexArrow(7, 234);//down arrow
//----
//---- name for DataWindow and indicator subwindow label
IndicatorShortName("Retracement(" + shortlookback + ")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| calculation                                                      |
//+------------------------------------------------------------------+
int start()
  {
  int limit,limit2,limit3;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

    
//Calculate the move up for the lookback period           
for(int i=0; i<limit; i++)
     {
       high[i]=iHigh(NULL,0,i);//
       shortlow[i]=iLow(NULL,0,(Lowest(NULL,0,MODE_LOW,shortlookback,(i))));
       upmove[i]=high[i]-shortlow[i];
       
       //Calculate the arrows
       if(upmove[i]>=shortmove*Point)//look for the condition of the arrow each bar is evaluated in the loop
       {downtrend[i]=high[i]+arrowsDisplacement;}       
     }
      
//Calculate the down move for the lookback period      
for(i=0; i<limit; i++)
     {
       low[i]=iLow(NULL,0,i);
       shorthigh[i]=iHigh(NULL,0,(Highest(NULL,0,MODE_HIGH,shortlookback,(i))));
       downmove[i]=shorthigh[i]-low[i];
       
       //Calculate the arrows
       if(downmove[i]>=shortmove*Point)//look for the condition of the arrow each bar is evaluated in the loop
       {uptrend[i]=low[i]-arrowsDisplacement;} // then return the value less the distance away from the value      
     } 
 
//Print("llv =" + llv[0] + " : hhv = " + hhv[0]);
//Print("high: ", DoubleToStr(high[0],4));  
//Print("downmove=" + downmove[0] + " : upmove = " + upmove[0]);   
       
   return(0);
//NOTE   

   

//---- done

  }
//+------------------------------------------------------------------+